﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
#IgnoreWarnings: 12

'Class module
Private Sub Class_Globals
	Private NativeMe As JavaObject
End Sub

'Initializes the object.
Public Sub Initialize
	NativeMe = Me
End Sub

'Encrypt a string with key and seed number.
Sub EncryptWithKey(Text As String, Key As String, Seed As Int) As String
	Return NativeMe.RunMethod("EncryptJava", Array (Text, Key, Seed))
End Sub
'Decrypt a string with key and seed number.
Sub DecryptWithKey(Text As String, Key As String, Seed As Int) As String
	Return NativeMe.RunMethod("DecryptJava", Array (Text, Key, Seed))
End Sub

'Encrypt a string with seed number.
Sub Encrypt(Text As String, Seed As Int) As String
	Return NativeMe.RunMethod("EncryptJava2", Array (Text, Seed))
End Sub
'Decrypt a string with seed number.
Sub Decrypt(Text As String, Seed As Int) As String
	Return NativeMe.RunMethod("DecryptJava2", Array (Text, Seed))
End Sub

#If JAVA

public static String EncryptJava(final String text, final String key, final int seed) {

	StringBuilder sb = new StringBuilder();
	
	int tmp = 0;
	for (int i = 0; i < key.length(); i++) {
		tmp += (int)(key.charAt(i));	
	}
	
	tmp %= seed; // Valore ipotetico che può essere cambiato
	tmp %= 32;
	for (int i = 0; i < text.length(); i++) {
		sb.append((char)(int)(text.charAt(i) + tmp));
	}
	
	return sb.toString();
}

public static String DecryptJava(final String text, final String key, final int seed) {

	StringBuilder sb = new StringBuilder();
	
	int tmp = 0;
	for (int i = 0; i < key.length(); i++) {
		tmp += (int)(key.charAt(i));
	}
	
	tmp %= seed; // Valore ipotetico che può essere cambiato
	tmp %= 32;
	for (int i = 0; i < text.length(); i++) {
      sb.append((char)(int)(text.charAt(i) - tmp));
	}
	
	return sb.toString();
}

public static String EncryptJava2(final String text, final int seed) {

	StringBuilder sb = new StringBuilder();
	
	final int tmp = text.length() % seed; // 16 originale
   final int len = text.length();
	
	for (int i = 0; i < len; i++) {
		sb.append((char)(int)(text.charAt(i) + tmp));
	}
	
	return sb.toString();
}

public static String DecryptJava2(final String text, final int seed) {

	StringBuilder sb = new StringBuilder();
	
	final int tmp = text.length() % seed; // 16 originale
   final int len = text.length();
	
	for (int i = 0; i < len; i++) {
     sb.append((char)(int)(text.charAt(i) - tmp));
	}
	
	return sb.toString();
}

#End If


'///////////////////////// RC4 //////////////////////////

Private Sub RC4Initialize(StrPwd As String, key() As Int, sbox()As Int)
	Dim tempSwap As Int
	Dim a As Int
	Dim b As Int = 0
	Dim intlength As Long

	intlength = StrPwd.Length
	
'	Log("Password len: "& intlength)
'	Dim str As String = "Massimo"
'	For i = 0 To str.Length-1
'		Log(i & "    " & Mid(str, i, 1))
'	Next
	
	For a = 0 To 255
		key(a) = Asc(Mid(StrPwd, a Mod intlength, 1))
		sbox(a) = a
	Next

	For a = 0 To 255
		b = (b + sbox(a) + key(a)) Mod 256
		tempSwap = sbox(a)
		sbox(a) = sbox(b)
		sbox(b) = tempSwap
	Next
End Sub

Private Sub Dec(Number As String) As String
	Dim base As String
	Dim iLen As Int
	Dim iReturn As Long
	Dim i As Long
	Dim iTemp As String
	 
	base = "0123456789ABCDEF"
	iLen = Number.Length
	
	For i = 0 To iLen - 1
		iTemp = Mid(Number, iLen - i - 1, 1)
		
'		Dim f As Int = base.IndexOf(iTemp.ToUpperCase) + 1
'		iReturn = iReturn + Power(16 , i) * (f - 1) 'iReturn = iReturn + (16 ^ i) * (sf.InString(base,iTemp) - 1)
		iReturn = iReturn + Power(16 , i) * base.IndexOf(iTemp.ToUpperCase)
	Next
	
	Return iReturn
End Sub

' If an encrypted string arrives from an application for PC or .net the decoding function is not correct.
' I rewrote the feature.
' The problem is in the xor function that should be performed only if the two parts are different otherwise it would result in 0.
' I hope it can help those who have had problems with rc4 decoding

'Decrypt a string using RC4 algorithm.
Sub RC4Decrypt(Text As String, Key As String) As String
   
	Dim sbox(256) As Int
	Dim akey(256) As Int
	
	Dim a As Long
	Dim i As Long
	Dim J As Long
	Dim k As Long
	Dim idx As Long
	Dim cipherby As Long
	
	Dim tmp As StringBuilder
	tmp.Initialize
	Dim cipher As StringBuilder
	cipher.Initialize
	
'	For a = 1 To text.ToUpperCase.Length Step 2 ' Originale
	For a = 1 To Text.Length Step 2
		tmp.Append (Chr(Dec(Mid(Text, a-1, 2))))
	Next

	For idx = 0 To 255
		sbox(idx) = idx
		akey(idx) = Asc(Key.CharAt((idx Mod Key.Length)))
	Next

	For i = 0 To 255
		j = (j + sbox(i) + akey(i)) Mod 256
		k = sbox(i)
		sbox(i) = sbox(j)
		sbox(j) = k
	Next
	
	i = 0
	J = 0
	
'	For idx = 1 To text.ToUpperCase.Length / 2 ' Originale
	''''''	For idx = 1 To text.Length / 2  ' Originale 2
	For idx = 1 To Bit.ShiftRight(Text.Length, 1)  'Ottimizzata
		i = (i + 1) Mod 256
		j = (j + sbox(i)) Mod 256
		
		k = sbox(i)
		sbox(i) = sbox(j)
		sbox(j) = k
			
		If Asc(Mid(tmp.ToString, idx-1, 1)) = sbox(((sbox(i)) + sbox(j)) Mod 256) Then
			cipherby = Asc(Mid(tmp, idx-1, 1))
		Else
			cipherby = (Bit.Xor(sbox(((sbox(i)) + sbox(j)) Mod 256), Asc(Mid(tmp, idx-1, 1))))
		End If
		  	  
		cipher.Append(Chr(cipherby))
	Next

	Return cipher.ToString
End Sub

'Encrypt a string using RC4 algorithm.
Sub RC4Encrypt(Text As String, Key As String) As String
	
	Dim sbox(256) As Int
	Dim akey(256) As Int
	
	Dim temp As Long
	Dim a As Long
	Dim i As Long = 0
	Dim j As Long = 0
	Dim k As Long
	Dim cipherby As Long
	
	Dim cipher As StringBuilder
	cipher.Initialize
	
	RC4Initialize(Key, akey, sbox)
    
	For a = 1 To Text.Length
		i = (i + 1) Mod 256
		j = (j + sbox(i)) Mod 256
		k = sbox(i)
		sbox(i) = sbox(j)
		sbox(j) = k

		temp = sbox((sbox(i) + sbox(j)) Mod 256)

		cipherby = Bit.Xor((Asc(Mid(Text, a-1, 1))), temp) 'BASE 0
			
		If Bit.ToHexString(cipherby).Length = 1 Then
			cipher.Append("0").Append(Bit.ToHexString(cipherby))
		Else
			cipher.Append(Bit.ToHexString(cipherby))
		End If
	Next

	Return cipher.ToString
End Sub

' Base 0
Private Sub Mid(Text As String, Start As Int, Length As Int) As String
	Return Text.SubString2(Start, Start + Length)
End Sub


' //////////// ARDUINO SIDE.  QUESTE DUE SEMBRA CHE VADANO BENE (VANNO VELOCI ESATTAMENTE UGUALI E SONO COMPARABILI) ///////////
' LA PIU VELOCE SEMBRA QUESTA, INOLTRE USA LA CHIAVE (PASSWORD) E LA LUNGHEZZA DELLA STRINGA CRIPTATA è UGUALE A QUELLA DECRIPTATA (ORIGINALE)    
' SEMBRA LA MIGLIORE

''Very fast and relatively secure XOR string encrypt/decrypt with key.
''This is a single function, call it to encrypt, recall with same password to decrypt.
'Sub XorMessage (Text As String, Key As String) As String
'	Dim out As StringBuilder
'	out.Initialize
'	
'	Dim msglen As Int = Text.Length
'	Dim keylen As Int = Key.Length
'
'	Dim n1 As Int
'	Dim n2 As Int
'
'	For i = 0 To msglen-1
'		n1 = Asc(Text.CharAt(i))
'		n2 = Asc(Key.CharAt(i Mod keylen))
'		out.Append(Chr(Bit.Xor(n1, n2)))
'	Next
'	Return out.ToString
'End Sub

' BY AGHRAM. MANY THANKSSS
Sub XorMessage (Text As String, Key As String) As String
		
	Dim bc As ByteConverter
	' US-ASCII only 0-127, ISO-8859-1 Latin 0-255   [US-ASCII]  [UTF-8] [ISO-8859-1]
	Dim TextBytes() As Byte = bc.StringToBytes(Text, "US-ASCII")
	Dim KeyBytes() As Byte = bc.StringToBytes(Key, "US-ASCII")
	
	Dim msglen As Int = TextBytes.Length
	Dim keylen As Int = KeyBytes.Length

	Dim byteOut(msglen) As Byte
	
	Dim n1 As Byte
	Dim n2 As Byte

	For i = 0 To msglen-1
		n1 = TextBytes(i)
		n2 = KeyBytes(i Mod keylen)
		byteOut(i) = Bit.Xor(n1, n2)
	Next
	Return bc.StringFromBytes(byteOut, "US-ASCII")
	
End Sub

'///////////// SHIFT ENCRYPTION //////////////

Sub ShiftEncrypt (Msg As String, Val As Byte) As String
	Dim offs As Byte = Val, stp As Byte = -1
	Dim Const msglen As Int = Msg.Length
'	Log("ShiftEncrypt: LEN: " & msglen)
	Dim out As StringBuilder
	out.Initialize
	For i = 0 To msglen-1
'		Log("ShiftEncrypt: [" & i & "] Offset: " & offs)
		Dim b As Int = Asc(Msg.CharAt(i)) + offs
'		Dim c As Char = Chr(b)
		out.Append(Chr(b))
'		out.Append(Chr(Asc(Msg.CharAt(i)) + offs))
		
		'out += (char) (signed char) (msg[i] + val);
		
		' Log ("ENCRYPT: [%d] - MOD: %d INPUT: [%c] dec: %d    OUTPUT: [%c] dec: %d     [%s]\n", i, mod, msg[i], (uint8_t)msg[i], c, (uint8_t)c, out.c_str());
		If Val > 0 Then
			offs = offs + stp
			If (offs <= 0) Then
				stp = 1
			Else If (offs >= Val) Then
				stp = -1
			End If
		End If
	Next
	Return out.ToString()
End Sub

Sub ShiftDecrypt (Msg As String, Val As Byte) As String
	Dim offs As Byte = Val, stp As Byte = -1
	Dim Const msglen As Int = Msg.Length
	'	Log("ShiftDecrypt: LEN: " & msglen)
	Dim out As StringBuilder
	out.Initialize
	For i = 0 To msglen-1
'		Log("ShiftDecrypt: [" & i & "] Offset: " & offs)
		Dim b As Int = Asc(Msg.CharAt(i)) - offs
		'      Dim c As Char = Chr(b)
		out.Append(Chr(b))
'		out.Append(Chr(Asc(Msg.CharAt(i)) - offs))
		
'		out.Append(Chr(Asc(Msg.CharAt(i)) - Val))
		
		' Log ("ENCRYPT: [%d] - MOD: %d INPUT: [%c] dec: %d    OUTPUT: [%c] dec: %d     [%s]\n", i, mod, msg[i], (uint8_t)msg[i], c, (uint8_t)c, out.c_str());
		If Val > 0 Then
			offs = offs + stp
			If (offs <= 0) Then
				stp = 1
			Else If (offs >= Val) Then
				stp = -1
			End If
		End If
	Next
	Return out.ToString()
End Sub

'//////////////

Sub Reverse (Msg As String)  As String
	
	Dim Const msglen As Int = Msg.Length
	Dim out As StringBuilder
	out.Initialize
	For i = msglen-1 To 0 Step -1
		out.Append(Msg.CharAt(i))
	Next
	Return out.ToString


End Sub
